Index: branches/UKMO/dev_r5518_GO6_package_fix_rnf_MOCI_TEST_SUITE/NEMOGCM/NEMO/OPA_SRC/IOM/iom.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_fix_rnf_MOCI_TEST_SUITE/NEMOGCM/NEMO/OPA_SRC/IOM/iom.F90	(revision 8194)
+++ branches/UKMO/dev_r5518_GO6_package_fix_rnf_MOCI_TEST_SUITE/NEMOGCM/NEMO/OPA_SRC/IOM/iom.F90	(revision 8195)
@@ -41,7 +41,9 @@
    USE dianam          ! build name of file
    USE xios
+   USE iom_def, ONLY : max_rst_fields, rst_fields
 # endif
    USE ioipsl, ONLY :  ju2ymds    ! for calendar
    USE crs             ! Grid coarsening
+   USE lib_fortran 
 
    IMPLICIT NONE
@@ -62,4 +64,5 @@
    PRIVATE iom_set_domain_attr, iom_set_axis_attr, iom_set_field_attr, iom_set_file_attr, iom_get_file_attr, iom_set_grid_attr
    PRIVATE set_grid, set_grid_bounds, set_scalar, set_xmlatt, set_mooring, iom_update_file_name, iom_sdate
+   PRIVATE set_rst_vars, set_rstr_active
 # endif
 
@@ -136,4 +139,5 @@
           &                                    start_date = xios_date(nyear,nmonth,nday,0,0,0) )
       END SELECT
+
 #endif
       ! horizontal grid definition
@@ -141,12 +145,13 @@
       CALL set_scalar
 
-      IF( TRIM(cdname) == TRIM(cxios_context) ) THEN  
-         CALL set_grid( "T", glamt, gphit ) 
-         CALL set_grid( "U", glamu, gphiu )
-         CALL set_grid( "V", glamv, gphiv )
-         CALL set_grid( "W", glamt, gphit )
+      IF( TRIM(cdname) == TRIM(cxios_context) .OR. TRIM(cdname) == TRIM(rxios_context)) THEN  
+         CALL set_grid( "T", glamt, gphit, ln_mskland ) 
+         CALL set_grid( "U", glamu, gphiu, ln_mskland )
+         CALL set_grid( "V", glamv, gphiv, ln_mskland )
+         CALL set_grid( "W", glamt, gphit, ln_mskland )
          CALL set_grid_znl( gphit )
+         CALL set_grid("N",glamt, gphit, .FALSE.)        ! not masked values
          !
-         IF( ln_cfmeta ) THEN   ! Add additional grid metadata
+         IF( ln_cfmeta .AND. TRIM(cdname) .NE. TRIM(rxios_context)) THEN   ! Add additional grid metadata
             CALL iom_set_domain_attr("grid_T", area = e12t(nldi:nlei, nldj:nlej))
             CALL iom_set_domain_attr("grid_U", area = e12u(nldi:nlei, nldj:nlej))
@@ -163,13 +168,13 @@
          CALL dom_grid_crs   ! Save the parent grid information  & Switch to coarse grid domain
          !
-         CALL set_grid( "T", glamt_crs, gphit_crs ) 
-         CALL set_grid( "U", glamu_crs, gphiu_crs ) 
-         CALL set_grid( "V", glamv_crs, gphiv_crs ) 
-         CALL set_grid( "W", glamt_crs, gphit_crs ) 
+         CALL set_grid( "T", glamt_crs, gphit_crs, ln_mskland ) 
+         CALL set_grid( "U", glamu_crs, gphiu_crs, ln_mskland ) 
+         CALL set_grid( "V", glamv_crs, gphiv_crs, ln_mskland ) 
+         CALL set_grid( "W", glamt_crs, gphit_crs, ln_mskland ) 
          CALL set_grid_znl( gphit_crs )
           !
          CALL dom_grid_glo   ! Return to parent grid domain
          !
-         IF( ln_cfmeta ) THEN   ! Add additional grid metadata
+         IF( ln_cfmeta .AND. TRIM(cdname) .NE. TRIM(rxios_context)) THEN   ! Add additional grid metadata
             CALL iom_set_domain_attr("grid_T", area = e1e2t_crs(nldi:nlei, nldj:nlej))
             CALL iom_set_domain_attr("grid_U", area = e1u_crs(nldi:nlei, nldj:nlej) * e2u_crs(nldi:nlei, nldj:nlej))
@@ -184,8 +189,8 @@
 
       ! vertical grid definition
-      CALL iom_set_axis_attr( "deptht", gdept_1d )
-      CALL iom_set_axis_attr( "depthu", gdept_1d )
-      CALL iom_set_axis_attr( "depthv", gdept_1d )
-      CALL iom_set_axis_attr( "depthw", gdepw_1d )
+      CALL iom_set_axis_attr( "deptht", paxis = gdept_1d )
+      CALL iom_set_axis_attr( "depthu", paxis = gdept_1d )
+      CALL iom_set_axis_attr( "depthv", paxis = gdept_1d )
+      CALL iom_set_axis_attr( "depthw", paxis = gdepw_1d )
 
       ! Add vertical grid bounds
@@ -227,5 +232,12 @@
       
       ! automatic definitions of some of the xml attributs
-      CALL set_xmlatt
+      IF( TRIM(cdname) == TRIM(rxios_context)) THEN
+!set names of the fields in restart file IF using XIOS to read/write data
+       CALL set_rst_vars()
+!set which fields are to be read from restart file
+       CALL set_rstr_active()
+      ELSE
+       CALL set_xmlatt
+      ENDIF
 
       CALL set_1point
@@ -241,7 +253,145 @@
 
 #endif
-      
+
    END SUBROUTINE iom_init
 
+   
+   SUBROUTINE set_rst_vars()
+!set names for variables in restart file
+
+        rst_fields(:)%vname="NO_NAME";         rst_fields(:)%grid="NO_GRID"
+
+        rst_fields(1)%vname="rdt";             rst_fields(1)% grid="grid_scalar"
+        rst_fields(2)%vname="rdttra1";         rst_fields(2)% grid="grid_scalar"      
+        rst_fields(3)%vname="un";              rst_fields(3)% grid="grid_N_3D"
+        rst_fields(4)%vname="ub";              rst_fields(4)% grid="grid_N_3D"
+        rst_fields(5)%vname="vn";              rst_fields(5)% grid="grid_N_3D"
+        rst_fields(6)%vname="vb";              rst_fields(6)% grid="grid_N_3D"  
+        rst_fields(7)%vname="tn";              rst_fields(7)% grid="grid_N_3D"
+        rst_fields(8)%vname="tb";              rst_fields(8)% grid="grid_N_3D"
+        rst_fields(9)%vname="sn";              rst_fields(9)% grid="grid_N_3D"
+        rst_fields(10)%vname="sb";             rst_fields(10)%grid="grid_N_3D"
+        rst_fields(11)%vname="sshn";           rst_fields(11)%grid="grid_N"
+        rst_fields(12)%vname="sshb";           rst_fields(12)%grid="grid_N"
+        rst_fields(13)%vname="hdivn";          rst_fields(13)%grid="grid_N_3D"
+        rst_fields(14)%vname="hdivb";          rst_fields(14)%grid="grid_N_3D"
+        rst_fields(15)%vname="rhop";           rst_fields(15)%grid="grid_N_3D"
+        rst_fields(16)%vname="rotn";           rst_fields(16)%grid="grid_N_3D"
+        rst_fields(17)%vname="rotb";           rst_fields(17)%grid="grid_N_3D"
+        rst_fields(18)%vname="kt";             rst_fields(18)%grid="grid_scalar"
+        rst_fields(19)%vname="ndastp";         rst_fields(19)%grid="grid_scalar"
+        rst_fields(20)%vname="adatrj";         rst_fields(20)%grid="grid_scalar"
+        rst_fields(21)%vname="utau_b";         rst_fields(21)%grid="grid_N"
+        rst_fields(22)%vname="vtau_b";         rst_fields(22)%grid="grid_N"
+        rst_fields(23)%vname="qns_b";          rst_fields(23)%grid="grid_N"
+        rst_fields(24)%vname="emp_b";          rst_fields(24)%grid="grid_N"
+        rst_fields(25)%vname="sfx_b";          rst_fields(25)%grid="grid_N"
+        rst_fields(26)%vname="en" ;            rst_fields(26)%grid="grid_N_3D" 
+        rst_fields(27)%vname="avt";            rst_fields(27)%grid="grid_N_3D"
+        rst_fields(28)%vname="avm";            rst_fields(28)%grid="grid_N_3D"
+        rst_fields(29)%vname="avmu";           rst_fields(29)%grid="grid_N_3D"
+        rst_fields(30)%vname="avmv";           rst_fields(30)%grid="grid_N_3D"
+        rst_fields(31)%vname="dissl";          rst_fields(31)%grid="grid_N_3D"
+        rst_fields(32)%vname="sbc_hc_b";       rst_fields(32)%grid="grid_N"
+        rst_fields(33)%vname="sbc_sc_b";       rst_fields(33)%grid="grid_N"
+        rst_fields(34)%vname="qsr_hc_b";       rst_fields(34)%grid="grid_N_3D"
+        rst_fields(35)%vname="gcx";            rst_fields(35)%grid="grid_N"
+        rst_fields(36)%vname="gcxb";           rst_fields(36)%grid="grid_N"
+        rst_fields(37)%vname="fraqsr_1lev";    rst_fields(37)%grid="grid_N"
+        rst_fields(38)%vname="greenland_icesheet_mass"
+                                               rst_fields(38)%grid="grid_scalar"
+        rst_fields(39)%vname="greenland_icesheet_timelapsed"
+                                               rst_fields(39)%grid="grid_scalar"
+        rst_fields(40)%vname="greenland_icesheet_mass_roc"
+                                               rst_fields(40)%grid="grid_scalar"
+        rst_fields(41)%vname="antarctica_icesheet_mass"
+                                               rst_fields(41)%grid="grid_scalar"
+        rst_fields(42)%vname="antarctica_icesheet_timelapsed"
+                                               rst_fields(42)%grid="grid_scalar"
+        rst_fields(43)%vname="antarctica_icesheet_mass_roc"
+                                               rst_fields(43)%grid="grid_scalar"
+        rst_fields(44)%vname="rhd";            rst_fields(44)%grid="grid_N_3D"
+        rst_fields(45)%vname="frc_v";          rst_fields(45)%grid="grid_scalar"
+        rst_fields(46)%vname="frc_t";          rst_fields(46)%grid="grid_scalar"
+        rst_fields(47)%vname="frc_s";          rst_fields(47)%grid="grid_scalar"
+        rst_fields(48)%vname="frc_wn_t";       rst_fields(48)%grid="grid_scalar"
+        rst_fields(49)%vname="frc_wn_s";       rst_fields(49)%grid="grid_scalar"
+        rst_fields(50)%vname="ssh_ini";        rst_fields(50)%grid="grid_N"
+        rst_fields(51)%vname="e3t_ini";        rst_fields(51)%grid="grid_N_3D"
+        rst_fields(52)%vname="hc_loc_ini";     rst_fields(52)%grid="grid_N_3D"
+        rst_fields(53)%vname="sc_loc_ini";     rst_fields(53)%grid="grid_N_3D"
+        rst_fields(54)%vname="ssh_hc_loc_ini"; rst_fields(54)%grid="grid_N"
+        rst_fields(55)%vname="ssh_sc_loc_ini"; rst_fields(55)%grid="grid_N"
+        rst_fields(56)%vname="fse3t_b";        rst_fields(56)%grid="grid_N_3D"
+        rst_fields(57)%vname="fse3t_n";        rst_fields(57)%grid="grid_N_3D"
+        rst_fields(58)%vname="tilde_e3t_b";    rst_fields(58)%grid="grid_N"
+        rst_fields(59)%vname="tilde_e3t_n";    rst_fields(59)%grid="grid_N"
+        rst_fields(60)%vname="hdiv_lf";        rst_fields(60)%grid="grid_N"
+        rst_fields(61)%vname="ub2_b";          rst_fields(61)%grid="grid_N"
+        rst_fields(62)%vname="vb2_b";          rst_fields(62)%grid="grid_N"
+        rst_fields(63)%vname="sshbb_e";        rst_fields(63)%grid="grid_N"
+        rst_fields(64)%vname="ubb_e";          rst_fields(64)%grid="grid_N"
+        rst_fields(65)%vname="vbb_e";          rst_fields(65)%grid="grid_N"
+        rst_fields(66)%vname="sshb_e";         rst_fields(66)%grid="grid_N"
+        rst_fields(67)%vname="ub_e";           rst_fields(67)%grid="grid_N"
+        rst_fields(68)%vname="vb_e";           rst_fields(68)%grid="grid_N"
+        rst_fields(69)%vname="fwf_isf_b";      rst_fields(69)%grid="grid_N"
+        rst_fields(70)%vname="isf_sc_b";       rst_fields(70)%grid="grid_N"
+        rst_fields(71)%vname="isf_hc_b";       rst_fields(71)%grid="grid_N"
+        rst_fields(72)%vname="ssh_ibb";        rst_fields(72)%grid="grid_N"
+        rst_fields(73)%vname="rnf_b";          rst_fields(73)%grid="grid_N"
+        rst_fields(74)%vname="rnf_hc_b";       rst_fields(74)%grid="grid_N"
+        rst_fields(75)%vname="rnf_sc_b";       rst_fields(75)%grid="grid_N"
+        rst_fields(76)%vname="nn_fsbc";        rst_fields(76)%grid="grid_scalar"
+        rst_fields(77)%vname="ssu_m";          rst_fields(77)%grid="grid_N"
+        rst_fields(78)%vname="ssv_m";          rst_fields(78)%grid="grid_N"
+        rst_fields(79)%vname="sst_m";          rst_fields(79)%grid="grid_N"
+        rst_fields(80)%vname="sss_m";          rst_fields(80)%grid="grid_N"
+        rst_fields(81)%vname="ssh_m";          rst_fields(81)%grid="grid_N"
+        rst_fields(82)%vname="e3t_m";          rst_fields(82)%grid="grid_N"
+        rst_fields(83)%vname="frq_m";          rst_fields(83)%grid="grid_N"
+        rst_fields(84)%vname="avmb";           rst_fields(84)%grid="Vgrid"
+        rst_fields(85)%vname="avtb";           rst_fields(85)%grid="Vgrid"
+
+   END SUBROUTINE set_rst_vars
+
+
+   SUBROUTINE set_rstr_active()
+!sets enabled = .TRUE. for each field in restart file
+#if defined key_xios2
+   CHARACTER(len=256) :: rst_file
+   TYPE(xios_field) :: field_hdl
+   TYPE(xios_file) :: file_hdl
+   TYPE(xios_filegroup) :: filegroup_hdl
+   INTEGER :: i
+   CHARACTER(lc)  ::   clpath
+
+        clpath = TRIM(cn_ocerst_indir)
+        IF( clpath(LEN_TRIM(clpath):) /= '/' ) clpath = TRIM(clpath) // '/'
+        IF( TRIM(Agrif_CFixed()) == '0' ) THEN
+           rst_file = TRIM(cn_ocerst_indir)//TRIM(cn_ocerst_in)
+        ELSE
+           rst_file = TRIM(cn_ocerst_indir)//'1_'//TRIM(cn_ocerst_in)
+        ENDIF
+!set name of the restart file and enable available fields
+        if(lwp) WRITE(numout,*) 'Setting restart filename (for XIOS) to: ',rst_file
+        CALL xios_get_handle("file_definition", filegroup_hdl )
+        CALL xios_add_child(filegroup_hdl, file_hdl, 'rrestart')
+        CALL xios_set_file_attr( "rrestart", name=trim(rst_file), type="one_file", &
+             par_access="collective", enabled=.TRUE., mode="read",                 &
+             output_freq=xios_timestep)
+!defin files for restart context
+        DO i = 1, max_rst_fields
+         IF( TRIM(rst_fields(i)%vname) /= "NO_NAME") THEN
+           IF( iom_varid( numror, TRIM(rst_fields(i)%vname), ldstop = .FALSE. ) > 0 ) THEN
+                CALL xios_add_child(file_hdl, field_hdl, TRIM(rst_fields(i)%vname))
+                CALL xios_set_attr (field_hdl, enabled = .TRUE., name = TRIM(rst_fields(i)%vname), &
+                     grid_ref = TRIM(rst_fields(i)%grid ), operation = "instant")
+                if(lwp) WRITE(numout,*) TRIM(rst_fields(i)%vname), ' enabled'
+           ENDIF
+         ENDIF
+        END DO
+#endif
+   END SUBROUTINE set_rstr_active
 
    SUBROUTINE iom_swap( cdname )
@@ -378,4 +528,6 @@
             icnt = icnt + 1
          END DO
+      ELSE
+         lxios_sini = .TRUE.
       ENDIF
       IF( llwrt ) THEN
@@ -567,9 +719,10 @@
    !!                   INTERFACE iom_get
    !!----------------------------------------------------------------------
-   SUBROUTINE iom_g0d( kiomid, cdvar, pvar, ktime )
+   SUBROUTINE iom_g0d( kiomid, cdvar, pvar, ktime, lrxios )
       INTEGER         , INTENT(in   )                 ::   kiomid    ! Identifier of the file
       CHARACTER(len=*), INTENT(in   )                 ::   cdvar     ! Name of the variable
       REAL(wp)        , INTENT(  out)                 ::   pvar      ! read field
       INTEGER         , INTENT(in   ),     OPTIONAL   ::   ktime     ! record number
+      LOGICAL         , INTENT(in   ),     OPTIONAL   ::   lrxios    ! use xios to read restart
       !
       INTEGER                                         ::   idvar     ! variable id
@@ -579,32 +732,45 @@
       CHARACTER(LEN=100)                              ::   clname    ! file name
       CHARACTER(LEN=1)                                ::   cldmspc   !
-      !
-      itime = 1
-      IF( PRESENT(ktime) ) itime = ktime
-      !
-      clname = iom_file(kiomid)%name
-      clinfo = '          iom_g0d, file: '//trim(clname)//', var: '//trim(cdvar)
-      !
-      IF( kiomid > 0 ) THEN
-         idvar = iom_varid( kiomid, cdvar )
-         IF( iom_file(kiomid)%nfid > 0 .AND. idvar > 0 ) THEN
-            idmspc = iom_file ( kiomid )%ndims( idvar )
-            IF( iom_file(kiomid)%luld(idvar) )  idmspc = idmspc - 1
-            WRITE(cldmspc , fmt='(i1)') idmspc
-            IF( idmspc > 0 )  CALL ctl_stop( TRIM(clinfo), 'When reading to a 0D array, we do not accept data', &
-                                 &                         'with 1 or more spatial dimensions: '//cldmspc//' were found.' , &
-                                 &                         'Use ncwa -a to suppress the unnecessary dimensions' )
-            SELECT CASE (iom_file(kiomid)%iolib)
-            CASE (jpioipsl )   ;   CALL iom_ioipsl_get(  kiomid, idvar, pvar, itime )
-            CASE (jpnf90   )   ;   CALL iom_nf90_get(    kiomid, idvar, pvar, itime )
-            CASE (jprstdimg)   ;   CALL iom_rstdimg_get( kiomid, idvar, pvar )
-            CASE DEFAULT    
-               CALL ctl_stop( 'iom_g0d: accepted IO library are only jpioipsl, jpnf90 and jprstdimg' )
-            END SELECT
-         ENDIF
-      ENDIF
+      LOGICAL                                         ::   lxios
+      !
+      lxios = .FALSE.
+      IF( PRESENT(lrxios) ) lxios = lrxios
+
+      IF(.NOT.lxios) THEN  ! read data using default library
+          itime = 1
+          IF( PRESENT(ktime) ) itime = ktime
+          !
+          clname = iom_file(kiomid)%name
+          clinfo = '          iom_g0d, file: '//trim(clname)//', var: '//trim(cdvar)
+          !
+          IF( kiomid > 0 ) THEN
+             idvar = iom_varid( kiomid, cdvar )
+             IF( iom_file(kiomid)%nfid > 0 .AND. idvar > 0 ) THEN
+                idmspc = iom_file ( kiomid )%ndims( idvar )
+                IF( iom_file(kiomid)%luld(idvar) )  idmspc = idmspc - 1
+                WRITE(cldmspc , fmt='(i1)') idmspc
+                IF( idmspc > 0 )  CALL ctl_stop( TRIM(clinfo), 'When reading to a 0D array, we do not accept data', &
+                                     &                         'with 1 or more spatial dimensions: '//cldmspc//' were found.' , &
+                                     &                         'Use ncwa -a to suppress the unnecessary dimensions' )
+                SELECT CASE (iom_file(kiomid)%iolib)
+                CASE (jpioipsl )   ;   CALL iom_ioipsl_get(  kiomid, idvar, pvar, itime )
+                CASE (jpnf90   )   ;   CALL iom_nf90_get(    kiomid, idvar, pvar, itime )
+                CASE (jprstdimg)   ;   CALL iom_rstdimg_get( kiomid, idvar, pvar )
+                CASE DEFAULT    
+                   CALL ctl_stop( 'iom_g0d: accepted IO library are only jpioipsl, jpnf90 and jprstdimg' )
+                END SELECT
+             ENDIF
+          ENDIF
+      ELSE
+#if defined key_iomput
+       IF(lwp) WRITE(numout,*) 'XIOS RST READ (0D): ', trim(cdvar)
+       CALL iom_swap( TRIM(rxios_context) )
+       CALL xios_recv_field( trim(cdvar), pvar)
+       CALL iom_swap( TRIM(cxios_context) )
+#endif
+      ENDIF   
    END SUBROUTINE iom_g0d
 
-   SUBROUTINE iom_g1d( kiomid, kdom, cdvar, pvar, ktime, kstart, kcount )
+   SUBROUTINE iom_g1d( kiomid, kdom, cdvar, pvar, ktime, kstart, kcount, lrxios )
       INTEGER         , INTENT(in   )                         ::   kiomid    ! Identifier of the file
       INTEGER         , INTENT(in   )                         ::   kdom      ! Type of domain to be read
@@ -614,12 +780,14 @@
       INTEGER         , INTENT(in   ), DIMENSION(1), OPTIONAL ::   kstart    ! start axis position of the reading 
       INTEGER         , INTENT(in   ), DIMENSION(1), OPTIONAL ::   kcount    ! number of points in each axis
+      LOGICAL         , INTENT(in   ),               OPTIONAL ::   lrxios    ! read data using XIOS
       !
       IF( kiomid > 0 ) THEN
          IF( iom_file(kiomid)%nfid > 0 ) CALL iom_get_123d( kiomid, kdom       , cdvar        , pv_r1d=pvar,   &
-              &                                                     ktime=ktime, kstart=kstart, kcount=kcount )
+              &                                                     ktime=ktime, kstart=kstart, kcount=kcount, &
+              &                                                     lrxios=lrxios )
       ENDIF
    END SUBROUTINE iom_g1d
 
-   SUBROUTINE iom_g2d( kiomid, kdom, cdvar, pvar, ktime, kstart, kcount, lrowattr )
+   SUBROUTINE iom_g2d( kiomid, kdom, cdvar, pvar, ktime, kstart, kcount, lrowattr, lrxios)
       INTEGER         , INTENT(in   )                           ::   kiomid    ! Identifier of the file
       INTEGER         , INTENT(in   )                           ::   kdom      ! Type of domain to be read
@@ -633,13 +801,14 @@
                                                                                ! called open_ocean_jstart to set the start
                                                                                ! value for the 2nd dimension (netcdf only)
+      LOGICAL         , INTENT(in   ),                 OPTIONAL ::   lrxios    ! read data using XIOS
       !
       IF( kiomid > 0 ) THEN
          IF( iom_file(kiomid)%nfid > 0 ) CALL iom_get_123d( kiomid, kdom       , cdvar        , pv_r2d=pvar,   &
               &                                                     ktime=ktime, kstart=kstart, kcount=kcount, &
-              &                                                     lrowattr=lrowattr )
+              &                                                     lrowattr=lrowattr,  lrxios=lrxios)
       ENDIF
    END SUBROUTINE iom_g2d
 
-   SUBROUTINE iom_g3d( kiomid, kdom, cdvar, pvar, ktime, kstart, kcount, lrowattr )
+   SUBROUTINE iom_g3d( kiomid, kdom, cdvar, pvar, ktime, kstart, kcount, lrowattr, lrxios )
       INTEGER         , INTENT(in   )                             ::   kiomid    ! Identifier of the file
       INTEGER         , INTENT(in   )                             ::   kdom      ! Type of domain to be read
@@ -653,9 +822,10 @@
                                                                                  ! called open_ocean_jstart to set the start
                                                                                  ! value for the 2nd dimension (netcdf only)
+      LOGICAL         , INTENT(in   ),                   OPTIONAL ::   lrxios    ! read data using XIOS
       !
       IF( kiomid > 0 ) THEN
          IF( iom_file(kiomid)%nfid > 0 ) CALL iom_get_123d( kiomid, kdom       , cdvar        , pv_r3d=pvar,   &
               &                                                     ktime=ktime, kstart=kstart, kcount=kcount, &
-              &                                                     lrowattr=lrowattr )
+              &                                                     lrowattr=lrowattr, lrxios=lrxios )
       ENDIF
    END SUBROUTINE iom_g3d
@@ -665,5 +835,5 @@
          &                  pv_r1d, pv_r2d, pv_r3d,   &
          &                  ktime , kstart, kcount,   &
-         &                  lrowattr                )
+         &                  lrowattr, lrxios        )
       !!-----------------------------------------------------------------------
       !!                  ***  ROUTINE  iom_get_123d  ***
@@ -686,5 +856,7 @@
                                                                            ! called open_ocean_jstart to set the start
                                                                            ! value for the 2nd dimension (netcdf only)
-      !
+      LOGICAL                    , INTENT(in   ), OPTIONAL ::   lrxios     ! use XIOS to read restart
+      !
+      LOGICAL                        ::   lxios       ! local definition for XIOS read
       LOGICAL                        ::   llnoov      ! local definition to read overlap
       LOGICAL                        ::   luse_jattr  ! local definition to read open_ocean_jstart file attribute
